/**
 * 
 */
package isp.zoom;

import java.awt.Graphics;
import java.awt.Image;
import java.text.NumberFormat;

import javax.swing.JPanel;

/**
 * @author Daniel Héctor Stolfi Rosso
 * ISP - VIGIA
 * panel para imagen
 */
public class JPImg extends JPanel {

	private
		Image img;
		String ruta;
		int factor, algoritmo;
	
	/**
	 * Constructor
	 * @param ruta Ruta de las imágenes
	 */
	public JPImg(String ruta) {
		this.ruta = ruta;
	    factor = 0;
	    algoritmo = 0;
	    aplicaZOOM();
	}
	
	/**
	 * Pinta imagen
	 */
	public void paint(Graphics g) {
		g.drawImage(img, 0, 0, img.getWidth(this), img.getHeight(this), this);
	}
	
	/**
	 * Función que acerca
	 */
	public void zoomIN() {
		if (factor < 10) {
			factor++;
			aplicaZOOM();
		}
	}
	
	/**
	 * Función que aleja
	 */
	public void zoomOUT() {
		if (factor > 0) {
			factor--;
			aplicaZOOM();
		}
	}
	
	/**
	 * Función que cambia el algoritmo
	 * @param algoritmo Algoritmo de redimensionado a utilizar
	 */
	public void setAlgoritmo(int algoritmo) {
		this.algoritmo = algoritmo;
		aplicaZOOM();
	}
	
	/**
	 * Función que cambia el factor del ZOOM
	 */
	private void aplicaZOOM() {
		// Transforma imagen
		this.factor = factor;
		img = corte(factor);
		img = zoom(factor);
		repaint();
	}
	
	/**
	 * Función zoom
	 * @param factor Factor ZOOM
	 */
	private Image zoom(int factor) {
		int alg;
		switch (algoritmo) {
		case 0: alg = Image.SCALE_AREA_AVERAGING; break;
		case 1: alg = Image.SCALE_DEFAULT; break;
		case 2: alg = Image.SCALE_FAST; break;
		case 3: alg = Image.SCALE_REPLICATE; break;
		case 4: alg = Image.SCALE_SMOOTH; break;
		default: alg = Image.SCALE_DEFAULT;
		}
		return img.getScaledInstance(800, 600, alg);		
	}

	/**
	 * Simulación Función Corte
	 * @param factor Índice de imagen a utilizar para simular corte
	 */
	private Image corte(int factor) {
		String fichero = ruta+String.format("%02d.jpg",factor);
		System.out.println(fichero);
		return getToolkit().getImage(fichero);
	}
}
