package isp.zoom;

import java.awt.GridLayout;
import java.awt.Insets;

import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JPanel;

/**
 * @author Daniel Héctor Stolfi Rosso
 * ISP - VIGIA
 * Zoom imagen
 */

public class Zoom extends JFrame {

	JPImg jPImg;
	JPanel jPBotonera;
	JButton jBZin, jBZout;
	JComboBox jCBAlg;

	/**
	 * Constructor
	 * @param fichero Ruta y patrón de nombre de los ficheros de imagen a visualizar
	 */
	public Zoom(String fichero) {		
		// Inicializa
		setLayout(null);
        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("ZOOM");
        setSize(815, 715);
        setResizable(false);
        
        Insets interior = getInsets();        
        
        // Imagen
		jPImg = new JPImg(fichero);
		add(jPImg);
		jPImg.setBounds(interior.left,
						interior.top, 
						800, 600);
		// Botones
		jBZin = new JButton("ZOOM IN");
        jBZin.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jPImg.zoomIN();
            }
        });
		jBZout = new JButton("ZOOM OUT");
        jBZout.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jPImg.zoomOUT();
            }
        });
        // Combo
        jCBAlg = new JComboBox();
        jCBAlg.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "SCALE_AREA_AVERAGING","SCALE_DEFAULT","SCALE_FAST","SCALE_REPLICATE","SCALE_SMOOTH" }));
        jCBAlg.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jPImg.setAlgoritmo(jCBAlg.getSelectedIndex());
            }
        });
        
		// Botonera
		jPBotonera = new JPanel(new GridLayout(1,3));
		jPBotonera.add(jBZin);
		jPBotonera.add(jCBAlg);
		jPBotonera.add(jBZout);
		add(jPBotonera);
		jPBotonera.setBounds(interior.left,
							 interior.top + jPImg.getHeight() + 2, 
							 800, 80);
	}
	
	/**
	 * @param args Se le pasa la ruta y patrón de nombre de los ficheros de imagen a visualizar
	 */
	public static void main(String[] args) {
		if (args.length < 1) { 
			System.out.println("Uso: Zoom ruta");
		} else {
			Zoom z = new Zoom(args[0]);
	        z.setVisible(true);		
		}		
	}

}
